HISTORY of the SCSI Mirage.
________________________________

Note: entries should start with a '*', be dated and initialed.
  This file should be in REVERSE date order

-----------------------------------------------------------------------------
Mods:
* 19/10/98 - jc (release 2.4.5i)
  Fix to buffer for emulation bug when timing model de-activated.

-----------------------------------------------------------------------------
Mods:
* 16/10/98 - jc (release 2.4.5g)
  Timing model improvements.

-----------------------------------------------------------------------------
Mods:
* 14/10/98 - jpa (release 2.4.5e)
Set Host Interrupt at end of transfer instead of using EIDE AutoEnd

-----------------------------------------------------------------------------
Mods:
* 14/10/98 - jpa (release 2.4.5d)
Small delay at end of read transfer interrupt
Use 2K block size

-----------------------------------------------------------------------------
Mods:
* 13/10/98 - jpa (release 2.4.5c)
Check DA Serial Number matches GDM Serial Number before issuing Switch Toggle

-----------------------------------------------------------------------------
Mods:
* 12/10/98 - jpa (release 2.4.5b)
GD switch bug fix

-----------------------------------------------------------------------------
Mods:
* 12/10/98 - jpa (release 2.4.5a)
Add GD switch toggle if Debug Adaptor detected on GD-Writer SCSI bus

-----------------------------------------------------------------------------
Mods:
* 09/10/98 - jpa (release 2.4.4c)
Add delay to EIDE Nop Command to match Gd-Drive Nop Command

-----------------------------------------------------------------------------
Mods:
* 08/10/98 - jc (release 2.4.4b)
Fix to buffer module we not fill over data yet to be read.
Fixes 18hr MPEG bug.

-----------------------------------------------------------------------------
Mods:
* 08/10/98 - jpa (release 2.4.4a)
Check Door Open on GetDiskFormat()

-----------------------------------------------------------------------------
Mods:
* 30/09/98 - jpa (release 2.4.3f)
CD_PLAY - restart ignore Repeat value
CD_SCD - detect PAUSE

-----------------------------------------------------------------------------
Mods:
* 29/09/98 - jpa (release 2.4.3e)
Single Density lead-out correction in Emulation

-----------------------------------------------------------------------------
Mods:
* 29/09/98 - jpa (release 2.4.3d)
Single Density lead-out correction
CD_SCD update Audio Status

-----------------------------------------------------------------------------
Mods:
* 17/09/98 - jpa (release 2.4.3c)
CD_READ2 command revised

-----------------------------------------------------------------------------
Mods:
* 15/09/98 - jc (release 2.4.3b)
Bug fix in FAT module to reset directory caching correctly between emulations.

-----------------------------------------------------------------------------
Mods:
* 14/09/98 - jpa (release 2.4.3a)
Subcode Q calculation + interleaving + checksum
Timing Model +/- 5% to seek
Open Door on switch to GD-Drive

-----------------------------------------------------------------------------
Mods:
* 09/09/98 - jpa (release 2.4.2d)
Track 2 GD-ROM burning corrected by 1 sector

-----------------------------------------------------------------------------
Mods:
* 04/09/98 - jpa (release 2.4.2c)
Mods
  bug fix in seek timing model
  split Acceleration and Deceleration times from Full Stroke time

-----------------------------------------------------------------------------
* 30/08/98 - jc
Mods:
  improve disc model to cope with seeks.

-----------------------------------------------------------------------------
Mods:
* 25/08/98 - jpa (release 2.4.2b)
MEDIA NOT PRESENT on Door Open

-----------------------------------------------------------------------------
Mods:
* 24/08/98 - jpa (release 2.4.2a)
Change EIDE revision to "rev a.01"
Do UNIT ATTENTION on Door Closed.

-----------------------------------------------------------------------------
Mods:
* 19/08/98 - jc (release 2.4.1c)
  Improved code that finds the * padding file to be more robust to small
changes in passing * from the GUI.

-----------------------------------------------------------------------------
Mods:
* 18/08/98 - jpa (release 2.4.1b)
Remove TrimExtents() from Filing System
Update Ident to GD-Drive Rev1.2

-----------------------------------------------------------------------------
Mods:
* 16/08/98 - jpa
CDR Abort during Write Improved
Door Open sets UNIT ATTENTION

-----------------------------------------------------------------------------
Mods:
* 10/08/98 - jpa (release 2.4.1a)


-----------------------------------------------------------------------------
Mods:
* 04/08/98 - jpa
CDR Abort without using Flush Cache, use Read Buffer Capacity until cache empty

-----------------------------------------------------------------------------
Mods:
* 04/08/98 - jc/jpa
  Separated FILETABLE module from the file system modules. Now have one
FileTable shared between 3 Filesystem modules.

-----------------------------------------------------------------------------
Mods:
* 04/08/98 - jpa
EIDE SoftReset - Abort timing model if Soft Reset occurred
	       - Reset Emulation before Soft Reset to EIDE
EIDE - successful read sets NoSense condition

-----------------------------------------------------------------------------
Mods:
* 04/08/98 - jc
  HFS code will now find files on an HFS and generate extents for files with
less than 3 extents. HFS support in Prepare to Emulate and HCD not yet added.

-----------------------------------------------------------------------------
Mods:
* 31/07/98 - jpa
Add EIDE SoftReset
Add AudioStop()

-----------------------------------------------------------------------------
Mods:
* 28/07/98 - jpa
Change CD-Switch so that GD-M always selected if no GD-Drive.
Ignore CD-Switch commands if no GD-Drive
AudioOff() on EIDE Reset and Read Command

-----------------------------------------------------------------------------
Mods:
* 23/07/98 - jpa
  Change Ident Version and Date to match GD-Drive 1.1 980623

-----------------------------------------------------------------------------
Mods:
* 22/07/98 - jc (release 2.4.0b)
  Fixed filler bug causing reflash from emulation drive problems.

jpa-
  Changed boot string to have meaning on SCSI-Mirage too.

-----------------------------------------------------------------------------
* 21/07/98 - jc (release 2.4.0a)
Mods:
  New HCD Mod. Added Unique Emulation ID (4bytes) before the Catalog Number.
  Now report this in the DWORD of the status packet when not burning a CD.
  Added support for extra Yamaha CD-Burners.
  Changed the Boot String to display the poduct name 1st.

jpa-
  Removed UBC stuff...slowing execution down too much.

-----------------------------------------------------------------------------
* 15/07/98 - jc (release 2.3.9l)
Mods:
  Removed all references to old fat and hfs files.
  Fixed Upgrade from Disk bug. Flag upgrading correctly.
  Removed timing of random disk reads at boot. Saves ~4 secs. Fixed
  some runaway NULL pointers in the FAT code. Added some Developer Cmds for
  HFS.

-----------------------------------------------------------------------------
* 10/07/98 - gw
Mods:
  Now use UBC as a code safeguard.

-----------------------------------------------------------------------------
* 10/07/98 - jpa (Version 2.3.9k)
Mods:
CD_SCAN (fast forward/reverse) full functionality added
Add Audio Repeat function
Fix Last Audio Track play bug
Revert to dynamic allocation for SCSI
-----------------------------------------------------------------------------
* 02/07/98 - jpa (Version 2.3.9i)
Mods:
   High GetTOC LeadOut value corrected.
   GD-R TOC now uses GetTrackStart() not GetPreGapStart.
   SetFormatStatus() on Initialisation dependant on Door Status
-----------------------------------------------------------------------------
* 02/07/98 - jc (Version 2.3.9h)
Mods:
   Fixed bug appearing with Adaptec PCMCIA SCSI cards. Changed the dynamic
allocation of SCSI transfer buffers to static allocation. Now error sensibly
when a to large a SCSI transfer is attempted on the Host Port.

Notes:
   Maximum size SCSI Transfer handled is now 512K. Above this limit the
emulator will refuse to transfer.

-----------------------------------------------------------------------------
* 30/06/98 - jc (Version 2.3.9g)
Mods:
    Fixed prepare to emulate bug...now succeeds in emulating large numbers of
directories. Small improvement in prepare to emulate time.
CDR - change to CTL/ADR spec for CDDA->MODE1 (0x01) 1sec Pregap
EIDE - Host Command interrupt tidyup
MAIN - Remove delay on EIDE Reset
-----------------------------------------------------------------------------
* 29/06/98 - jpa
Tidy up EIDE RequestStatus command - spec v1.21 incorrect Control/Address
Read Command set CD position with cache lookahead
Set CD-R PREPARING flag immediatley on BurnDiskAtOnce

-----------------------------------------------------------------------------
* 29/06/98 - jpa/jc (Version 2.3.9e)
Mods:
   Open Door when flashing
   Prevent Buffer Empty when playing audio
   Use Buffer Memory for flash down wire
   Check prepare to emulate flag before attempting to prepare again.
   No longer send message to log unless flag is clear.

Notes:

-----------------------------------------------------------------------------
* 28/06/98 - jc (Version 2.3.9b)
Mods:
   Fixed a logging bug that caused bad errors in the log. Now pass a
terminating empty log message to GUI.

Notes:

-----------------------------------------------------------------------------
* 28/06/98 - jc (Version 2.3.9a)
Mods:
   Fixed a bug in the reset eeprom defaults code. Now ensure the HardDisk ID
is never reset and ensure we get a fresh copy of the new config structure from
the eeprom.

Notes:

-----------------------------------------------------------------------------
* 24/06/98 - jc (Version 2.3.8c release)
Mods:
   Re-instated intelligent SCSI bus scan feature. If no drive is on the
expected SCSI ID then the 1st valid drive in the bus scan will become the
emulation drive instead.

Notes:
   Known Firmware Bugs Outstanding:
1>Errors when number of files dropped onto workshop exceed file limitations.

2>Errors when directories created named Dir0 - Dir511.

3>'ERROR3:' messages in log window.

-----------------------------------------------------------------------------
* 24/06/98 - gw
Mods:
   Internal bus scan would miss certain devices as they took a long time to
appear on the bus (Quantum Fireball 2G took >2seconds).  We now repeatedly
scan all empty IDs until we have been powered for 3 seconds.  This gives
devices approximately 4 seconds to become active.

Notes:
   Once consequence was that it was possible for the emulation drive to be
running in async. mode.  This could cost %10-%15 disk subsystem performance.

-----------------------------------------------------------------------------
* 24/06/98 - jpa (Version 2.3.8b release)
Mods:

EIDE - Read Subcode command update.
     - Set CD Position more accurately on read command

CDR - support 75+150 Pregap for CDDA->MODE1 Track changes

MAIN - Term Power Fuse Blown log message on Power-up

-----------------------------------------------------------------------------
* 23/06/98 - jc
Mods:
Improve method of scanning the devices on the bus at boot. Now devices appear
more reliably.

-----------------------------------------------------------------------------
* 18/06/98 - jc (Version 2.3.7a release)
Mods:
TIMING - Improvement of timing model accuracy.
Fixed bug that hung the box when emulating without the timing model.
Fixed bug that hung the box when opening door during a read.

EIDE - Modifications & Improvements.

EMULATION - Now clear Auto-Emulate status if a project fails to emulate. F

FAT32 - Fixed how we handle Int13 FAT32 Partitions.

Notes:
New top speed without timing model is ~26X
Includes changes from 16/06/98 documented below.

-----------------------------------------------------------------------------
* 16/06/98 - jc
Mods:
Fixed start-up bug to ensure we wait before scanning the devices on the bus.
Removed Automatic selection of emulation drive when expected ID is empty,
in-case drive is changed without user noticing.

Notes:
adds an extra 1/2 second to our boot-time

-----------------------------------------------------------------------------
* 09/06/98 - jpa (Version 2.3.6a release)

Change VENDOR ID on Host SCSI to CPL
Convert NTFS Short filename to Uppercase
Add Padding Track to REL Table (FAT & NTFS)

Notes:
-----------------------------------------------------------------------------

-----------------------------------------------------------------------------
* 05/06/98 - jpa (Version 2.3.5a release)
Mods:
NTFS            - Search of additional Index Buffer Entries in Cluster
		- Improved Test for Directory existence for Auto-Emulate
		- Allow Short and Long Filenames
EIDE            - Support GET_TOC format for CD-ROM as well as GD-ROM
EMULATOR        - Add Reset Emulation function for Hard Reset
CDR             - Add Medium Sense command to test for record disk before Writing
REL TABLE       - Check for negative Gap Size
BUFFER          - Correction to read last block in buffer
Notes:
-----------------------------------------------------------------------------
* 04/06/98 - jc
Mods:
Fixed FAT32 module to recognise Int13 partitions.

Notes:

-----------------------------------------------------------------------------
* 29/05/98 - jpa (Version 2.3.4b release)
Mods:
Emulator sets SectorSize correctly when CDDA Track
CDR session 1 Track 2 changed to correct Data/Postgap sizes
Add check of free memory on startup
Notes:
-----------------------------------------------------------------------------
* 27/05/98 - jpa (Version 2.3.4a release)
Mods:
BUF_SIZE reduced to 1MB
Increase MAX_NTFS_FILENAME to 40
Use MAX_NTFS_FILENAME for all filenames in NTFS
Notes:

-----------------------------------------------------------------------------
* 26/05/98 - jpa (Version 2.3.3a release)
Mods:
Set SectorsPerCluster in ConfigManager for Timing Model in NTFS
Improve File Chaining for NTFS
Notes:


-----------------------------------------------------------------------------
* 22/05/98 - jpa (Version 2.3.2d release)
Mods:
Fixed new buffer/filler mechanism to work properly on GD-M.
Re-instated all associated changes and improvements to timing model.
NTFS correct block length when on SECTOR_SIZE boundary.
GD-R updated to latest tasks
EIDE GetToc changed to handle Select bit
Notes:


-----------------------------------------------------------------------------
* 18/05/98 - jc (Version 2.3.2b release)
Mods:
Fixed new buffer/filler mechanism to work properly on GD-M.
Re-instated all associated changes and improvements to timing model.
All modules now adhere to the new filesys structure in SCSI-Mirage.
NTFS long/short file-name handling improved.

Notes:

-----------------------------------------------------------------------------
* 14/05/98 - jc (Version 2.3.1f release)
Mods:
fixed eeprom SetDefaults. No longer overwrites serial number etc.
Also stop emulating before we attempt an eeprom default reset.

Notes:

-----------------------------------------------------------------------------
* 14/05/98 - jc (Version 2.3.1e release)
Mods:
Fixed auto-emulate bug to prevent a null string from becoming the
auto-emulate path.

Notes:

-----------------------------------------------------------------------------
* 14/05/98 - jc (Version 2.3.1d release)
Mods:
Removed some EIDE debug.
Fixed a Logging bug, reporting CD sector size incorrectly.

Notes:

-----------------------------------------------------------------------------
* 13/05/98 - jc (Version 2.3.1c release)
Mods:
Retain boot number after resetting eeprom defaults.
Sped up the eeprom re-initialise, previously causing ASPI timeout.
Will now identify an HFS disk in the SCSI bus scan.

Notes:
When upgrading from a pre 2.3.1a version of firmware, the Hard Disk should
default to reporting as removable.

When upgrading from Version 2.3.1a,

if the Hard Disk was set to report as removable in version 2.3.1a it will
default to being fixed after the first re-boot to v2.3.1c

if the Hard Disk was set to report as fixed inn version 2.3.1a then it will
default to being removable after the first re-boot to v2.3.1c

-----------------------------------------------------------------------------
* 05/05/98 - jc (Version 2.2.2b release)
	Various improvements to the Buffer / Filler mechanism. Now supports
the emulation timing model properly.
	Fixed srb-clash timeout problem preventing reliable copying of
multiple files to the hard disk.
	Enhanced FAT32 support...will now search for the BPB if now initially
where it is expected.
	Support for making Hard Disk report as removable to allow /z format
command from OSR2.
	Support for varied seek timing.

-----------------------------------------------------------------------------
* 23/04/98 - jc (Version 2.2.1b release)
	Tidy up of code, implementing new more logical layering of modules.
Fix to a Target Hard Disk bug affecting copying files to the Hard Disk.

-----------------------------------------------------------------------------
* 20/04/98 - jc (Version 2.2.0a release)
	  If there is no drive on the ID we expect, just make the 1st drive
in the scan the emulation drive.

-----------------------------------------------------------------------------
* 26/03/98 - jc (Version 2.0.1 release)
	Fixed config settings to ignore redundant values before prepare to
emulate.

-----------------------------------------------------------------------------
* 19/03/98 - jc (Version 2.0.0 release)
	Implemented new reflashing scheme.

-----------------------------------------------------------------------------
* 17/03/98 - jc
	Fixed re-flashing bugs.

-----------------------------------------------------------------------------
* 16/03/98 - jc
	Fixed auto-emulate & test burn bugs.

-----------------------------------------------------------------------------
* 11/03/98 - jc (Version 1.5.3) Release
	Fixed Problems with seeing the emulator in the SCSI card BIOS scan by
attempting to activate the chips more often after a reset.
	Re-allowed access to the Hard Disk during burning. Fixed a GD-M bug
which caused ASPI errors on a Prepare To Emulate.

-----------------------------------------------------------------------------
* 11/03/98 - jc (Version 1.5.1) Release
	To work with the 1.5.* GUI.

-----------------------------------------------------------------------------
* 10/03/98 - jc
	Re-allowed access to Hard Disk during emulation. This restores the
verify feature & auto-emulation.

-----------------------------------------------------------------------------
* 05/03/98 - jc
	Fixed FATParse bug causing bad emulations

-----------------------------------------------------------------------------
* 05/03/98 - jc (Version 1.4.3) Release
	Fixed < 8192 single extent emulation files bug.
  gw - Added remote flashing down wire.  Now no need to place .FSH file onto
the emulation hard drive when upgrading.  This will be supported on the host
soon.

-----------------------------------------------------------------------------
* 04/03/98 - gw
  Fixed glitch in PowerCycle/reset code.
  HD is now offline (no media) whilst an emulation is active and the door of
the CD is closed OR you are burning a gold disc.  This prevents the user
corrupting the disk drive whilst we are using it.
  CD Inquiry strings could contain non-ASCII characters.  Now space padded.

-----------------------------------------------------------------------------
* 02/03/98 - gw Now reject access to unsupported LUNs better.  Report power
  cycles/bus resets more accurateley.  Targets no longer issue BUS RESET at
  power up.  All three of the above have made the targets more stable on the
  SCSI bus.

-----------------------------------------------------------------------------
* 27/2/98 - jc
	fixed expansion bus scan bug. Maintain integrity of emulation tables
when we query the drives connected. Nudge timeout added. Log now keep latest
entries instead of oldest entries.

-----------------------------------------------------------------------------
* 26/2/98 - jc (Version 1.4.1 Release)
	Implemented enhanced HCD with new multi-VDS fix. Implemented padding
CD-DA track. Hard/Soft Errors and Nudge facility added. CD Inquiry string
fixed so we now report as whatever drive we are emulating

-----------------------------------------------------------------------------
* 23/2/98 - jc
	Removed all legacy logging and errors. now everything adheres to the
new scheme.

-----------------------------------------------------------------------------
* 20/2/98 - jc
   fixed the timing model compromises. fixed audio gaps bug. Basic hard errors
implemented. Timing Model now incorporates focus-time.

-----------------------------------------------------------------------------
* 17/2/98 - gw
  Added product codes to 'fsh' files to help prevent the burning of a flash
for the wrong product.  Fixed a small problem in logging that could present
extra data in the log.
  Host port now responds to StartUnit command.

-----------------------------------------------------------------------------
* 13/2/98 - jc  (Version 1.2.1 Release [on Friday the 13th])
  New, improved logging scheme reinstated. Handle new form of HCD with the
sector errors info.

-----------------------------------------------------------------------------
* 12/2/98 - jc
  Now support FAT32 drives with large FAT's correctly.

-----------------------------------------------------------------------------
* 9/2/98 - gw
  Added support for the Yamaha 400 series of CDR drives (that includes the
4000 series).  Fixed problem with gaps between audio tracks in 400 series.

-----------------------------------------------------------------------------
* 6/2/98 - jc (Version 1.1.2 Release)
	Swicthed back to old logging codes to aid current gui compatibility.

-----------------------------------------------------------------------------
* 2/2/98 - jc
	Big tidy up. New serial line debug improvements.

-----------------------------------------------------------------------------
* 26/1/98 - jc [Version 1.0.16 Release].
	More developer serial line debug added. Now allows the expansion bus
to be interrogated, to determine file systems and cluster sizes of drives.

-----------------------------------------------------------------------------
* 20/1/98 - jc [Version 1.0.15 Release].
  Now supports emulation from a FAT32 drive, so can handle drives bigger than
2 GB. Added some debug hooks to make the serial line output more useful to
Mirage developers. Small bug fix to better catch files absent from the
emulation drive. Added some extra warnings. FAT code tidy up. Will no longer
try to emulate when emulation files are missing.

-----------------------------------------------------------------------------
* 13/1/98 - gw
  The targets now report a PowerupReset in the TUR sense data once after a
boot (Sense data 0x06:0x29:0x00).  This informs the host that it should
re-initialise the target - eg. Negotiate again.  So, now you can actually
reset the target and the host should be able to recover.

-----------------------------------------------------------------------------
* 12/1/98 - jc
  fixed ickle problem in TOC class to ensure proper zeroing of the TOC
structure when new disk is inserted.

-----------------------------------------------------------------------------
* 12/1/98 - gw
  There was a problem when an async target was asked to do sync mode.
Consequence could time out the PC SCSI adapter upon boot.  Fixed.
  Disabled Target initiated sync negotiation.  Now we no longer do reboots
whilst the host is still running this function is no longer needed, and it
caused problems with certain SCSI adapters (As stated possible in the SCSI-2
book).
  Targets now resume to Async mode upon a bus reset.

-----------------------------------------------------------------------------
* 18/12/97 - jc - Version 1.0.14(***10th Full Release***)
	Fixed bug that caused problems when the same file appeared twice in an
emulated CD.

-----------------------------------------------------------------------------
* 17/12/97 - gw/jc - Version 1.0.12(***9th Full Release***);
  Added Target initated sync negotiation to targets.  Now means we should
survive power cycles much better.
  Integrated the separate TOCs into one. Now we sort Tracks into LSN order
in-case they have been shuffled round in the GUI.

-----------------------------------------------------------------------------
* 12/12/97 - jc - Version 1.0.11 (***8th Full Release***).Fixed mixed mode
verify bug. Now bail out properly when LSNs from GUI don't make sense.
	   -gw - Don't enable SCSI chips on boot until after the
interrupts are in place to allow us to reply properly. Should eliminate remote
reset problem that can hang ASPI layer.

-----------------------------------------------------------------------------
* 10/12/97 - jc - Version 1.0.10 (***7th Full Release***).Fixed strange bug
that prevented proper emulation of >5 tracks.

-----------------------------------------------------------------------------
* 10/12/97 - jc - Version 1.0.9 (***6th Full Release***).Fixed another memory
allocation problem that was preventing test-burning.

-----------------------------------------------------------------------------
* 09/12/97 - jc - Version 1.0.8 (***5th Full Release***).Fixed a static memory
allocation bug for ReadTOC.

-----------------------------------------------------------------------------
* 08/12/97 - jc/gw - Version 1.0.7 (***4th Full Release***).Plugged a memory
leak on emulation.
  The target CD now appears on the Mac due to updates of the ModeSense
command.

-----------------------------------------------------------------------------
* 05/12/97 - jc - Version 1.0.6 (***3rd Full Release***).Cranked up File Limit
to 8192. Track Limit to 99.

-----------------------------------------------------------------------------
* 04/12/97 - jc - Version 1.0.5 (***2nd Full Release***).Various bug fixes.
  Bad Leadout bug fixed. Inter-Track audio play bug fixed.

-----------------------------------------------------------------------------
* 04/12/97 - gw
  Fixed problems with selection/LUN/ModeSense.  Mirage HD now appears on
Macintosh.

-----------------------------------------------------------------------------
* 21/11/97 - jc - Version 1.0.3 (***2nd Full Release***).Various bug fixes.
Features new abort burn facility. HCD Handled more intelligently...
incorporating sessions data. HFS walking improved not yet activated. Improved
error handling in REL module. Fixed Audio burning bug.

-----------------------------------------------------------------------------
* 13/11/97 - jc - Version 1.0.0 (***Actual First Full Release***).Various bug
fixes. Cope with altered HCD (but for one session only). Increased speed from
new Magic numbers for the DRAM, Hashing of directory searches. Increased
logging and error handling. Fixed directory searching bug. Added ability to
reset Mirage from front-end.

-----------------------------------------------------------------------------


-----------------------------------------------------------------------------
* 14/10/97 - jc - Version 0.7.1d (dev release not properly tested)
  Various bug fixes. Handle new version of the HCD. Further improved logging
and errors.

-----------------------------------------------------------------------------
* 7/10/97 - jc - Version 0.6.2d (dev release not properly tested)
  Merged the Logging and error reporting mechanisms. This allows us to report
more helpful data to the Mirage Workshop and tidies up the code in General

-----------------------------------------------------------------------------
* 29/9/97 - jc - Version 0.6.1d (dev release not properly tested)
  Now emulate gaps and burn MODE1, MODE1/CDDA, CDDA CD's with gaps. Various
improvements in debug, audio play handling, Tosh mode10sense response,

-----------------------------------------------------------------------------
* 17/9/97 - gw - Version 0.6.0b
  The host can now inquire about devices on the expansion bus.  This makes
user configuration easier.

-----------------------------------------------------------------------------
* 16/9/97 - gw
  Can now use the Hard Disk when it is in 'floppy format' - as created from
Win95 explorer sometimes (when no partition is present).

-----------------------------------------------------------------------------
* 28/8/97 - gw
  Fixed bad reporting of current CDR position.  This cured a percentage glitch
in the GUI.

-----------------------------------------------------------------------------
* 28/8/97 - jc
  Fixed prepare bug that failed to skip files that weren't in the emulation.
Fixed filler bug that tried to DMA the odd byte, of a file 1 byte less than a
sector boundary, twice...ending up trying to DMA zero bytes. Added a check in
the DMA module to ensure DMA's of zero bytes are not allowed.

-----------------------------------------------------------------------------
* 26/8/97 - gw
  Implemented get CDR speed command so GUI can select speed to make CDR at.
  Made the error message more useful when a buffer underrun occurs.
	  - jc
  Enhanced error handling stuff. Shouldn't allow emulation when files have
not been found.

-----------------------------------------------------------------------------
* 20/8/97 - jc/gw - Version 0.4.1b
  Fixed Audio bug. Now reset LastReadLB properly between emulations

-----------------------------------------------------------------------------
* 18/8/97 - gw
  Fixed the '5:5' bad phase on initiator problem.
	  - jc
  Fixed HCD walker to accomodate FileName size before files in HCD
-----------------------------------------------------------------------------
* 17/8/97 - jc/gw - Version 0.3.2b
  Fixed the emulation bugs introduced in the last release. Prep emulate is now
very speedy. Files no longer go missing in emulation. Flash burn has been
tested

-----------------------------------------------------------------------------
* 14/8/97 - jc/gw - Version 0.3.1b
  Now handle padding to the end of current CD sector properly not just to end
of current HD LB.

-----------------------------------------------------------------------------
* 13/8/97 - jc/gw - Version 0.3.0b
  The target ports will now reinitialise every five seconds if the bus is bad.
  This means that you can now turn on the Mirage before the target or host
  machine and it will recover.
  CD emulation timing is now more accurate
  to a real CD player.
  Fixed missing Files and File mismatch problems with large number of small
  files.
  Changed HCD format hence the minor version number change. Now only
compatible with 0.3.X.X Mirage WorkShop versions.

-----------------------------------------------------------------------------
* 1/8/97 - jc - Version 0.2.11b
  Made the audio player stuff less flaky. grab mode select data when it
happens.
  Gerally speeded things up.  Host hard disk access is faster.  Prepare to
emulate time is faster.
  Fixed problems with filenames larger than 64 characters or 9 directories.
Limits are now 128 characters, 64 directories deep.

-----------------------------------------------------------------------------
* 30/7/97 - jc - Big fix for un-ordered files bug.

-----------------------------------------------------------------------------
* 24/7/97 - jc - fixed reltable gapsize bug. Concurrent fillertask bug. Added
timeout to m_Idle wait. should fix 5movs bug.

-----------------------------------------------------------------------------
* 24/7/97 - jc - fixed pause/resume bug. various other tidy ups
	release Version 0.2.8b

-----------------------------------------------------------------------------
* 23/7/97 - jc - fixed chain boundary bug in fatparse.cpp. Could solve many
problems.

-----------------------------------------------------------------------------
* 22/7/97 - jc/gw - Version 0.2.7b
	LogMask default is now zero so by default all logging comes out
	TestTones can now be disabled via config.
	Failing good emulations now fixed.
	CDR better at detecting blank media.

-----------------------------------------------------------------------------
* 21/7/97 - gw - Version 0.2.6b
  First out of the door release.  Fixed a DMA bug that stopped the host
software from retrieving the status of the Mirage.

-----------------------------------------------------------------------------
* 18/7/97 - gw - Version 0.2.5b
  CD-R Test/Burn works for single Mode1 track.  Status now returned to host
software.  Prepare to emulate now asynchronous to command, thus avoiding SCSI
timeouts on large projects.

-----------------------------------------------------------------------------
* 17/7/97 - gw - Version 0.2d Initial version of CD burning code available.
  Yamaha CDR102/4 support only at this time.  Prepare to emulate partially on
  its way to being asyncronous to prevent SCSI timeouts on large emulations.

-----------------------------------------------------------------------------
* 17/7/97 - jc
(v0.2c Pre-Beta). Emulation fairly stable.
       -features handles new HCD version numbers


-----------------------------------------------------------------------------

* 14/7/97 - jc
First Ever Release (v0.2a Pre-Beta). Emulation fairly stable.

	- test projects.
	 mode1.cpj (mode 1 emulation)[missing dir PVD problem]
	 cdda.cpj (cdda emulation)

	-gui version
	 v1.0.0.1

	-features
	 Single track Mode1. Single Track CDDA. Prep emulate speedup

-----------------------------------------------------------------------------













